import usb
import time
import os
from subprocess import call
run = True
datafirst =[]

####################################
VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT1  = 2
VENDOR_RQ_GET_LIGHT2  = 3
VENDOR_RQ_GET_LIGHT3  = 4
VENDOR_RQ_GET_LIGHT4  = 5

####################################
class Board:
	def __init__(self):
        #print "Looking for MCU board..."
		dev = self.find_board()
		if not dev: raise "MCU board not found!"
        #print "MCU board found"
		self.handle = dev.open()

	def find_board(self):
		for bus in usb.busses():
			for dev in bus.devices:
 				if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
					return dev
		return None
	
	def set_led(self,pin,val):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
		self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin,timeout=100000)

	def get_switch(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH, 1,timeout=100000)
		return buf[0]

	def get_light1(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT1, 2)
		return buf[1]*256+buf[0]

	def get_light2(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT2, 2)
		return buf[1]*256+buf[0]

	def get_light3(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT3, 2)
		return buf[1]*256+buf[0]

	def get_light4(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT4, 2)
		return buf[1]*256+buf[0]

def minimum():
	##print datalist
	if datalist[0]<datalist[1] and datalist[0]<datalist[2]  and datalist[0]<datalist[3] :
		##print " a is minimum "		
		return 1
	elif datalist[1]<datalist[0] and datalist[1]<datalist[2]  and datalist[1]<datalist[3] :
		##print " b is minimum "
		return 2
	elif datalist[2]<datalist[0] and datalist[2]<datalist[1]  and datalist[2]<datalist[3] :
		##print " c is minimum "
		return 3
	elif datalist[3]<datalist[0] and datalist[3]<datalist[1]  and datalist[3]<datalist[2] :
		##print " d is minimum "
		return 4


b = Board()
def listdatafirst():
	datafirst.append(b.get_light1())
	datafirst.append(b.get_light2())
	datafirst.append(b.get_light3())
	datafirst.append(b.get_light4())
	return datafirst

def checkfirst():
	x1=0
	datafirst.append(b.get_light1())
	datafirst.append(b.get_light2())
	datafirst.append(b.get_light3())
	datafirst.append(b.get_light4())
	
	for i in datafirst :
		x1+=i
	return x1

global status
status = 0
p1=0
p2=0
oldStatus = 0
LIST = ['0','0']

def AddList():
	if p1 ==1 and p2 == 2:
		LIST[1] = LIST[0]
		LIST[0] = 'previous'
	elif p1 ==2 and p2 ==1:
		LIST[1] = LIST[0]
		LIST[0] = 'next'
	elif p1 ==3 and p2==4:
		LIST[1] = LIST[0]
		LIST[0] = 'down'
	elif p1 ==4 and p2==3:	
		LIST[1] = LIST[0]
		LIST[0] = 'up'
	elif p1==p2:
		if p1 ==1:
			LIST[1] = LIST[0]
			LIST[0] = 'play'
		elif p1 ==2:
			LIST[1] = LIST[0]
			LIST[0] = 'pause'
		elif p2 ==3:
			LIST[1] = LIST[0]
			LIST[0] = 'hide'
		elif p2 ==4:	
			LIST[1] = LIST[0]
			LIST[0] = 'notify'

def player():
	if LIST[1] == 'play' and LIST[0] == 'previous':
		os.system("rhythmbox-client --previous")
		status = 5 
		print 'previous'
	elif LIST[1] == 'pause' and LIST[0] == 'next':
		os.system("rhythmbox-client --next")
		print 'next'
		status = 6
	elif LIST[1] == 'hide' and LIST[0] == 'down':
		os.system("rhythmbox-client --volume-down")
		status= 7
		print 'down'
	elif LIST[1] == 'notify' and LIST[0] == 'up':
		os.system("rhythmbox-client --volume-up")
		status = 8
		print 'up'
	elif LIST[0] == LIST[1]:
		if LIST[0] =='play':
			os.system("rhythmbox-client --play")
			status = 1 
			print 'play'
		elif LIST[0] == 'pause':
			os.system("rhythmbox-client --pause")
			status = 2
			print 'pause'
		elif LIST[0] == 'hide':
			os.system("rhythmbox-client --")
			status = 3
			print 'hide'
		elif LIST[0] == 'notify':	
			os.system("rhythmbox-client --notify")
			status = 4
			print 'notify'

def IsQuit():
	##print datalist
	if datalist[0]<300 and datalist[1]<300 and datalist[2]<300 and datalist[3]<300:
		os.system("rhythmbox-client --quit")
		time.sleep(2)
	

os.system("rhythmbox-client")
print run
mean1 = checkfirst()
print mean1
datafirst[:]=[]
time.sleep(1)
mean2 = checkfirst()
print mean2
print "datafirst is",datafirst
datalist=[]
datalist=datafirst[:]
datafirst[:]=[]

while (run) :
	IsQuit()
	if mean1-mean2>=260: ##and  mean1-mean2<=500:	
		time.sleep(0.1)
		mean3unused = checkfirst()
		p2 = minimum()
		datafirst[:]=[]
		AddList()
		player()		

	mean2 = checkfirst()
	p1= minimum()
	datalist=datafirst[:]
	datafirst[:]=[]

print "stop"

        

